define bi_bash::exec (
    $command = $name,
    $user,
    $creates = undef,
    $cwd = undef,
    $environment = undef,
    $group = undef,
    $logoutput = undef,
    $onlyif = undef,
    $path = undef,
    $provider = "posix",
    $refresh = undef,
    $refreshonly = undef,
    $returns = undef,
    $timeout = undef,
    $tries = undef,
    $try_sleep = undef,
    $umask = undef,
    $unless = undef
) {
    # inspired by https://gist.github.com/DracoBlue/9870435
    
    require ::bi_bash
    require ::bi_coreutils::su::params
    
    if $cwd != undef {
        #notice("cwd is not null: [$cwd]")
        $escaped_command = regsubst("cd $cwd && $command", "\"", "\\\"", 'G')
    } else {
        $escaped_command = regsubst($command, "\"", "\\\"", 'G')
    }
    
    if $unless == undef {
        $escaped_unless = undef
    } else {
        if $cwd != undef {
            $unless_with_escaped_quotes = regsubst("cd $cwd && $unless", "\"", "\\\"", 'G')    
        } else {
            $unless_with_escaped_quotes = regsubst($unless, "\"", "\\\"", 'G')
        }
        
        $escaped_unless = "$::bi_coreutils::su::params::exe_path -l $user -c \"$::bi_bash::exe_path --login -c \\\"$unless_with_escaped_quotes\\\"\""
    }
 
    if $onlyif == undef {
        $escaped_onlyif = undef
    } else {
        if $cwd != undef {
            $onlyif_with_escaped_quotes = regsubst("cd $cwd && $onlyif", "\"", "\\\"", 'G')
        } else {
            $onlyif_with_escaped_quotes = regsubst($onlyif, "\"", "\\\"", 'G')    
        }
        
        $escaped_onlyif = "$::bi_coreutils::su::params::exe_path -l $user -c \"$::bi_bash::exe_path --login -c \\\"$onlyif_with_escaped_quotes\\\"\""
    }
   
    
    exec { $name:
        command => "$::bi_coreutils::su::params::exe_path -l $user -c \"$::bi_bash::exe_path --login -c \\\"$escaped_command\\\"\"",
        creates => $creates,
        cwd => $cwd,
        environment => $environment,
        group => $group,
        logoutput => $logoutput,
        onlyif => $escaped_onlyif,
        path => $path,
        provider => $provider,
        refresh => $refresh,
        refreshonly => $refreshonly,
        returns => $returns,
        timeout => $timeout,
        tries => $tries,
        try_sleep => $try_sleep,
         # umask => $umask,
        unless => $escaped_unless,
    }
}